<!----------------------------------------------------------------------------------------------------------------------
  -- siteHeader.vue
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <b-navbar
        id="site-header"
        toggleable="lg"
        type="dark"
        variant="primary"
    >
        <b-navbar-brand to="/">
            <fa icon="home"></fa>
            precursors-docs
        </b-navbar-brand>

        <b-navbar-toggle target="nav-collapse"></b-navbar-toggle>

        <b-collapse
            id="nav-collapse"
            is-nav
        >
            <b-navbar-nav>
                <!--                <b-nav-item to="/" class="bordered">-->
                <!--                    {{ siteName }}-->
                <!--                </b-nav-item>-->
                <b-nav-item
                    to="/sitemap"
                    class="bordered"
                >
                    Sitemap
                </b-nav-item>
            </b-navbar-nav>

            <!-- Right aligned nav items -->
            <b-navbar-nav class="ml-auto">
                <b-nav-item-dropdown
                    v-for="(pageList, name) in $categories"
                    :key="name"
                    class="bordered"
                    :text="name"
                    right
                >
                    <b-dropdown-item
                        v-for="page in pageList"
                        :key="page.slug"
                        :to="page.permalink"
                    >
                        {{ page.title }}
                    </b-dropdown-item>
                </b-nav-item-dropdown>

                <b-nav-form
                    class="ml-2"
                    @submit.stop.prevent
                >
                    <v-select
                        ref="pageSearch"
                        v-model="selectedPage"
                        class="search"
                        placeholder="Search Docs..."
                        :reduce="page => page.permalink"
                        :options="pages"
                        :filter="filter"
                        @input="onHit"
                    ></v-select>
                </b-nav-form>
            </b-navbar-nav>
        </b-collapse>
    </b-navbar>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss" scoped>
    #site-header {
        .search {
            min-width: 300px;
        }

        .logo {
            height: 64px;
            margin-top: -12px;
            margin-bottom: -12px;
            margin-left: -32px;
            margin-right: -16px;
        }
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script>
//------------------------------------------------------------------------------------------------------------------

    import Fuse from 'fuse.js';

    //------------------------------------------------------------------------------------------------------------------

    export default {
        name: 'SiteHeader',
        data()
        {
            return {
                selectedPage: undefined
            };
        },
        computed: {
            pages()
            {
                return this.$pages
                    .concat()
                    .filter((page) => page.slug !== 'sitemap')
                    .map((page) =>
                    {
                        return {
                            id: page.internal.id,
                            title: page.title,
                            content: page.content,
                            permalink: page.permalink,
                            label: page.title
                        };
                    });
            },
            siteName()
            {
                return this.$siteConfig.title;
            }
        },
        mounted()
        {
            const options = {
                keys: [ 'title', 'content' ],
                id: 'id'
            };
            this.$fuse = new Fuse(this.pages, options);
        },
        methods: {
            onHit(slug)
            {
                if(slug)
                {
                    this.$nextTick()
                        .then(() =>
                        {
                            this.$refs.pageSearch.clearSelection();
                            this.$router.push(slug);
                        });
                } // end if
            },
            filter(options, search)
            {
                const matching = this.$fuse.search(search);
                return options.filter((opt) => matching.includes(opt.id));
            }
        }
    };
</script>

<!--------------------------------------------------------------------------------------------------------------------->
